/*
 *  Alpha-Mini CCD Cam Driver
 *
 *  Copyright (C) 2000 Florin Boariu.
 *	
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Created: February 2000
 */

#ifndef __PGTOOLS_H
#define __PGTOOLS_H

void sendmsg (const char *issue, const char *fmt, ...);
void sendfile (const char *name);                  /* send a text file */
void pgopen (const char *title, const char *cap);  /* close HTML page */
void pgclose (void);                               /* open HTML page */

#define senderr(fmt,args...)  sendmsg("Error",fmt,##args)
#define sendwarn(fmt,args...) sendmsg("Warning",fmt,##args)
#define sendpre(fmt,args...)  sendmsg(NULL,fmt,##arfs)

#define MAXPGHEAD 16384
#define MAXPGTAIL 16384

#ifndef TMPLDIR
#define TMPLDIR "/usr/local/www/cgi-bin/tmpl"
#endif /* TMPLDIR */

#endif /* __PGTOOLS_H */
