/*
 *  Alpha-Mini CCD Cam Driver
 *
 *  Copyright (C) 2000 Florin Boariu.
 *	
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Created: May 8th, 2000
 */

#include <stdio.h>
#include <syslog.h>

#include <cgi.h>

#include <pgtools.h>

int main (int argc, char **argv)
{
	const char *head, *title, *body;
	const char def[]="Alpha Mini";

	openlog ("mkpg", LOG_CONS | LOG_PERROR, LOG_USER);

	if (!cgi_init ()) {
		fprintf (stderr, "Content-type: text/plain\n\n");
		fprintf (stderr, "cannot init cgi environment: %s\n",
			 cgi_strerror (cgi_errno));
		/*fprintf (f, "cannot init cgi environment: %s\n",
			cgi_strerror (cgi_errno));*/
		exit (0);
	}

	title = cgi_param ("title");
	if (!title) title = def;

	head = cgi_param ("head");
	if (!head) head = def;

	body = cgi_param ("body");

	pgopen (title, head);
	
	if (body) sendfile (body);
	else senderr ("no body specified!\n");

	pgclose ();
	
	return 0;
}
