#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
#include <stdio.h>
#include <getopt.h>
#include <iostream>
#include <string>

#include <cronic/loop.hh>
#include <sky/core/joblistdir.hh>
#include <sky/core/jobshellcore.hh>

#define OPT_SPOOLDIR  'd'
#define OPT_TIMESLICE 't'
#define OPT_HELP      'h'

void show_help_run (const char *name)
{
	fprintf (stderr, "\
Usage: %s OPTIONS\n\
\n\
Valid OPTIONS are:\n\
\n\
     -d,--spooldir dir  Spool directory to use.\n\
     -t,--timeslice sec The timeslices to use (in seconds).
     -h,--help          Print this screen and exits.\n\
\n", name);
}

int prog_run (int argc, char **argv)
{
	struct option opts[]={{"spooldir", 1, NULL, OPT_SPOOLDIR},
			      {"timeslice",1, NULL, OPT_TIMESLICE},
			      {"help",     0, NULL, OPT_HELP}};
	int opt;
	string dir;
	double slice=1.0;

	while (0 < (opt=getopt_long(argc, argv, "d:t:h", opts, NULL))) {
		switch (opt) {
		case OPT_SPOOLDIR:
			dir = optarg;
			break;

		case OPT_TIMESLICE:
			slice = atof(optarg);
			break;

		case OPT_HELP:
			show_help_run (argv[0]);
			exit(0);
			break;

		default:
			cerr << argv[0] << ": ignoring unknown option "
			     << optarg << endl;
			break;
		}
	}

	JobListDir jobs(dir);
	JobShellCore shell;
	Loop (slice, &jobs, &shell).run();
}
