#include <stdio.h>
#include <math.h>

/*
 * dependencies:
 *
 * maximum speed
 * maximum acceleration (step)
 */

#define RAMP_MAX 100
struct ramp {
	double speed[RAMP_MAX];
	double dist[RAMP_MAX];
	int size;
	double tslice;
};

void mkaccramp (struct ramp *ramp, int size, double max_t, double max_sp) 
{
	int i;
	double t = 0.0;
	double speed;
	ramp->size = size;
	ramp->tslice = max_t/(double)size;

	printf ("%d %f\n", ramp->size, ramp->tslice);

	for (i = 0; i < size; i++,t+=ramp->tslice) {
		speed = max_sp*(1.0-1.0/exp(t));
		ramp->speed[i] = speed;
		printf ("%f\n", speed);
		/*ramp->dist[i] = (i > 0 ? ramp->dist[i-1] : 0.0) + ramp->tslice*speed;
		printf ("adding: %.5f %.5f %.5f\n", t, ramp->speed[i], ramp->dist[i]);*/
	}
}

/* inline double get_speed_ramp (double time, struct ramp *ramp) */
/* { */
/* 	int i; */
/* 	if (time >= ramp->maxx) { */
/* 		return ramp->maxy; */
/* 	} else { */
/* 		i  = (int)(time * ramp->size/ramp->maxx); */
/* 	} */
/* } */

inline double get_speed (double time, double maxt, double maxsp)
{
	return maxsp*(1.0-1.0/exp(time*3.0/maxt));
}

double old_speed = 0.0;
int old_ramp = 0;

double increase_speed (double speed, struct ramp *ramp)
{
	double spd = old_speed;
	int i = old_ramp+1;
	if (speed > ramp->speed[ramp->size-1]) speed = ramp->speed[ramp->size-1];
	
	while (i < ramp->size) {
		if (i < 0) spd = -ramp->speed[-i];
		else spd = ramp->speed[i];
		if (i >= ramp->size || spd >= speed) goto last_step;
		i++;
		printf ("setting to %.5f\n", spd);
	}
 last_step:
	printf ("finally setting to %.5f\n", speed);
	old_speed = speed;
	old_ramp = i;
}

double decrease_speed (double speed, struct ramp *ramp)
{
	double spd = old_speed;
	int i = old_ramp-1;
	if (speed < -ramp->speed[ramp->size-1]) speed = -ramp->speed[ramp->size-1];
	
	while (i < ramp->size) {
		if (i < 0) spd = -ramp->speed[-i];
		else spd = ramp->speed[i];
		if (i >= ramp->size || spd <= speed) goto last_step;
		i--;
		printf ("setting to %.5f\n", spd);
	}
 last_step:
	printf ("finally setting to %.5f\n", speed);
	old_speed = speed;
	old_ramp = i;
}

int main (int argc, char **argv)
{
	struct ramp ramp;
	int size = atoi (argv[1]);
	double t = (double)atoi (argv[2]);
	double s = (double)atoi (argv[3]);
	int i;
	
	for (i = 0; i < argc; i++) {
		fprintf (stderr, "%s\n", argv[i]);
	}

	fprintf (stderr, "accelerating to %f in %f seconds and %d steps\n",
		 s, t, size);
	
	mkaccramp (&ramp, size, t, s);
}

int test (void)
{
	double d;
	int foo;
	struct ramp ramp;
	
	mkaccramp (&ramp, 30, 2.0, 5000.0);

	increase_speed (3333.3, &ramp);
	increase_speed (4444.4, &ramp);
	decrease_speed (2222.2, &ramp);
	decrease_speed (-2222.2, &ramp);
	increase_speed (1111.1, &ramp);

/* 	printf ("start\n"); */
/* 	for (d = 0.0; d < 3.0; d+=.000001) {		 */
/* 		//printf ("%.5f: %.5f\t\t", d, get_speed(d, 3.0, 10.0)); */
/* 		//printf ("%.5f: %.5f\n", d, get_speed_ramp(d, &ramp)); */

/* 		//get_speed(d, 3.0, 10.0); */
/* 		get_speed_ramp(d, &ramp); */
/* 	} */
/* 	printf ("end\n"); */

	return 0;
}


