#include <network.h>
#include <errno.h>
#include <stdio.h>

int startserv(int _port, int _backlog)
{
	int _sock;
	struct sockaddr_in loc_addr;

	if (-1 == (_sock = socket (AF_INET, SOCK_STREAM, 0))) {
		perror ("socket");
		return -1;
	}

	loc_addr.sin_family = AF_INET;
	loc_addr.sin_port   = htons(_port);
	loc_addr.sin_addr.s_addr = INADDR_ANY;
	bzero (&(loc_addr.sin_zero), 8);

	if (-1 == bind(_sock, (struct sockaddr*)&loc_addr,
		       sizeof(struct sockaddr))) {
		perror ("bind");
		return -1;
	}

	if (-1 == listen(_sock, _backlog)) {
		perror ("listen");
		return -1;
	}

	return _sock;
}

int getconn(int _sock)
{
	int ssize = sizeof(struct sockaddr_in);
	int fd;
	struct sockaddr_in loc_addr, rem_addr;	

	if (-1 == (fd = accept(_sock, (struct sockaddr*)&rem_addr, &ssize))) {
		perror ("accept");
		return -1;
	}
	
	return fd;
}


