#include <sky/user/user.hh>
#include <sky/user/cgi.hh>
#include <sky/user/cgi2.hh>
#include <fstream>
#include <sys/types.h>
#include <unistd.h>
#include <cronic/time.hh>

#include <map>
#include <string>

int main (int argc, char **argv)
{
	cgi_init();
	printf("Content-type: text/html\n\n");
	map<string,string> chmap;

	const char *uname = cgi_param("uname");
	const char *upass = cgi_param("upass");
	const char *start = cgi_param("start");

	const char *s  = cgi_param("skin");
	string skin = s ? s : "default";

	chmap["!!SKIN!!"] = skin;

	if (!uname || !upass) {
		chmap["!!ERROR!!"] = "User name and password needed!";
		cgi_send_file (skin+"/etc/err.tpl", &chmap);
		return 0;
	}
	if (!start) {
		chmap["!!ERROR!!"] = "Internal error -- no start page specified!";
		cgi_send_file (skin+"/etc/err.tpl", &chmap);
		return 0;
	}

	UserSession ses;       

	if (skyCheckUser(uname, upass)) {
		ses.setVal("uname", uname);
		ses.setVal("upass", upass);		
		ses.setVal("skin", skin);
		if (!ses.store()) {
			chmap["!!ERROR!!"] = "Internal error -- could not write session id!";
			cgi_send_file ("./error.tpl", &chmap);
		} else {
			chmap["!!SESID!!"] = ses.id();
			chmap["!!USER!!"]  = uname;
			cgi_send_file(skin+"/login/loginok.tpl", &chmap);
		}
	} else {
		chmap["!!ERROR!!"] = "Access denied. Your presence here is not desired.";
		cgi_send_file("error.tpl", &chmap);
	}

	cgi_done();
}





