#include <sky/user/cgi.hh>
#include <sky/core/joblistdir.hh>
#include <sky/user/user.hh>
#include <sky/user/cgi2.hh>
#include <fstream>
#include <map>
#include <string>

#define JOBDIR "/home/florin/pro/skylark/test"
//#define JOBDIR "."

int main (int argc, char **argv)
{
	cgi_init();
	printf("Content-type: text/html\n\n");
	
	const char *sesid = cgi_param("sesid");
	if (!sesid) sesid="";
	map<string,string> chmap;

	UserSession ses(sesid);
	ses.restore();
	chmap["!!SESID!!"] = ses.id();
	
	string uname = ses.getVal ("uname", "");
	string upass = ses.getVal ("upass", "");
	string skin = ses.getVal ("skin", "default");

	if (!skyCheckUser(uname.c_str(), upass.c_str())) {
		chmap["!!ERROR!!"] = "You don't have sufficient permission.";
		cgi_send_file (skin+"/etc/err.tpl", &chmap);	       
	}

	const char *tmp = cgi_param("jobid");
	string jobid = tmp ? tmp : "";
	for (int i=0; i < jobid.length(); i++) if (jobid[i]==' ') jobid[i]='+';

	if (!jobid.length()) {
		chmap["!!ERROR!!"] = "No job ID specified.";
		cgi_send_file (skin+"/etc/err.tpl", &chmap);
		return 0;
	}


	JobListDir jobs;
	jobs.init (JOBDIR);
	jobs.lock();
	if (jobid.length()) {
		JobData old;
		if (jobs.find(jobid, old)) {
			jobs.validate(old);
			// check if user == job_user, then rm job
			if (old.fetch("uname") != uname) {
				chmap["!!ERROR!!"] = "This is not your job!";
				cgi_send_file (skin+"/etc/err.tpl", &chmap);
				return 0;
			} else {
				jobs.discard (old.id());
			}
		} else {
			chmap["!!ERROR!!"] = "The specified job ID is not valid!";
			cgi_send_file (skin+"/etc/err.tpl", &chmap);
			return 0;
		}
	}
	jobs.unlock();

	chmap["!!TITLE!!"] = "Results";
	chmap["!!HEAD!!"] = "Succes";
	chmap["!!MESSAGE!!"] = "Job deleted";
	cgi_send_file (skin+"/etc/msg.tpl", &chmap);

	cgi_done();
}





