#ifndef mon03h_hpp
#define mon03h_hpp 1

/* *************************************************************** */

/* fuer das Programm verwendeter IO-Port                           */
/* auf 8-bit Einsteckkarte jumperbar                               */
/* MSB direkt am PC-Kartenstecker, unterste 2 bit sind Adressraum  */
/* und deswegen nicht jumperbar                                    */
/* default : hex 388                                               */

#define MON_Port   0x388

/* Registeradressen des jeweils verwendeten Ports                  */
#define MotOReg    0x00
#define MotIReg    0x00
#define AuxReg     0x01
#define PicDataReg 0x01
#define DACReg     0x02

/* Macros fuer die Motor-PIC-Kommunikation                         */

#define  RW_1_low	  MotOVal&=~0x01;outportb(MON_Port+MotOReg,~MotOVal)
#define  RW_1_high	  MotOVal|=0x01; outportb(MON_Port+MotOReg,~MotOVal)
#define  RW_2_low	  MotOVal&=~0x04;outportb(MON_Port+MotOReg,~MotOVal)
#define  RW_2_high	  MotOVal|=0x04; outportb(MON_Port+MotOReg,~MotOVal)
#define  RW_3_low	  MotOVal&=~0x10;outportb(MON_Port+MotOReg,~MotOVal)
#define  RW_3_high	  MotOVal|=0x10; outportb(MON_Port+MotOReg,~MotOVal)
#define  RW_4_low	  MotOVal&=~0x40;outportb(MON_Port+MotOReg,~MotOVal)
#define  RW_4_high	  MotOVal|=0x40; outportb(MON_Port+MotOReg,~MotOVal)

#define  DI_1_low	  MotOVal&=~0x02;outportb(MON_Port+MotOReg,~MotOVal)
#define  DI_1_high	  MotOVal|=0x02; outportb(MON_Port+MotOReg,~MotOVal)
#define  DI_2_low	  MotOVal&=~0x08;outportb(MON_Port+MotOReg,~MotOVal)
#define  DI_2_high	  MotOVal|=0x08; outportb(MON_Port+MotOReg,~MotOVal)
#define  DI_3_low	  MotOVal&=~0x20;outportb(MON_Port+MotOReg,~MotOVal)
#define  DI_3_high	  MotOVal|=0x20; outportb(MON_Port+MotOReg,~MotOVal)
#define  DI_4_low	  MotOVal&=~0x80;outportb(MON_Port+MotOReg,~MotOVal)
#define  DI_4_high	  MotOVal|=0x80; outportb(MON_Port+MotOReg,~MotOVal)

#define  GetCLK_1	  ((~inportb(MON_Port+MotIReg)>>0)&0x01)
#define  GetCLK_2         ((~inportb(MON_Port+MotIReg)>>2)&0x01)
#define  GetCLK_3         ((~inportb(MON_Port+MotIReg)>>4)&0x01)
#define  GetCLK_4         ((~inportb(MON_Port+MotIReg)>>6)&0x01)

#define  GetDO_1	  ((~inportb(MON_Port+MotIReg)>>1)&0x01)
#define  GetDO_2          ((~inportb(MON_Port+MotIReg)>>3)&0x01)
#define  GetDO_3          ((~inportb(MON_Port+MotIReg)>>5)&0x01)
#define  GetDO_4          ((~inportb(MON_Port+MotIReg)>>7)&0x01)

#define  PSTR_low	  AuxVal&=~0x01;outportb(MON_Port+AuxReg,AuxVal)
#define  PSTR_high        AuxVal|= 0x01;outportb(MON_Port+AuxReg,AuxVal)
#define  PA0_low	  AuxVal&=~0x02;outportb(MON_Port+AuxReg,AuxVal)
#define  PA0_high         AuxVal|= 0x02;outportb(MON_Port+AuxReg,AuxVal)
#define  PA1_low	  AuxVal&=~0x04;outportb(MON_Port+AuxReg,AuxVal)
#define  PA1_high         AuxVal|= 0x04;outportb(MON_Port+AuxReg,AuxVal)
#define  RESPIC_low	  AuxVal&=~0x40;outportb(MON_Port+AuxReg,AuxVal)
#define  RESPIC_high      AuxVal|= 0x40;outportb(MON_Port+AuxReg,AuxVal)

#define  RESET_low	  AuxVal|= 0x80;outportb(MON_Port+AuxReg,AuxVal)
#define  RESET_high       AuxVal&=~0x80;outportb(MON_Port+AuxReg,AuxVal)

#define  GetPicData       (inportb(MON_Port+PicDataReg))

#define  SetDAC(V)	  DACVal=V;outportb(MON_Port+DACReg,DACVal)

void   MON_Reset (void);
void   MON_SetDAC (unsigned char value);
double MON_GetClk (void);
int    MON_TransCeive1 (double spd, int pd, double *pos, char *lim);
int    MON_TransCeive2 (double spd, int pd, double *pos, char *lim);
int    MON_TransCeive3 (double spd, int pd, double *pos, char *lim);
int    MON_TransCeive4 (double spd, int pd, double *pos, char *lim);

/**********************************************************************/

#endif
