/* *************************************************************** */
/* Testprogramm fuer MON03-Hardware 							   */
/*     (Fahren einer Sinusgeschwindigkeit mit Ausgabe von		   */
/*     aktueller Position und Endlagenposition					   */
/*     (C) OES GmbH / FF 12-Oct-97								   */
/*     TAB-Spacing = 4											   */
/* *************************************************************** */

/* *************************************************************** */
/* INCLUDE-Files												   */
/* *************************************************************** */

#include <math.h>       // Nur fuer sin, cos, usw.
#include <stdio.h>      // Nur fuer formatierten Output
#include <conio.h>		// Nur fuer gotoxy // Positionieren des Cursors
#include "MON03H.HPP"   // Fuer direkte Motorsteuerung

/* *************************************************************** */
/* Hauptprogramm												   */
/* *************************************************************** */

main()
{
  printf("Loeschen des Bildschirms durch etliche CR!\n");
  printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
  printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");

  gotoxy(1,1); printf("RESET der Steuerung!\n");
  MON_Reset();

  printf("Sinus-Geschwindigkeitsvorgabe fuer Motoren 1..4 (20 mal je sec)!\n");
  char       lim1;
  char       lim2;
  char       lim3;
  char       lim4;
  double     pos1, spd1;
  double     pos2, spd2;
  double     pos3, spd3;
  double     pos4, spd4;
  double	 time, starttime;

  starttime = MON_GetClk();
  gotoxy(1,12); printf ("Starten der Endlosschleife       !\n");
  for (int i=0; i<10000; i+=1)
  {
	do    { time = MON_GetClk(); }
	while ( (time-starttime) < 0.05*i ); // 20 mal je sekunde

	gotoxy(1,12); printf ("Reden mit 1. Motor               !\n");
	spd1 = sin((double)i/10000.*3.14159*2.)*500.; // 1 Schwingung
	MON_TransCeive1(spd1, 1, &pos1, &lim1);

	gotoxy(1,12); printf ("Reden mit 2. Motor               !\n");
	spd2 = sin((double)i/ 5000.*3.14159*2.)*500.; // 2 Schwingungen
	MON_TransCeive2(spd2, 1, &pos2, &lim2);

	gotoxy(1,12); printf ("Reden mit 3. Motor               !\n");
	spd3 = sin((double)i/ 2500.*3.14159*2.)*500.; // 3 Schwingungen
	MON_TransCeive3(spd3, 1, &pos3, &lim3);

	gotoxy(1,12); printf ("Reden mit 4. Motor               !\n");
	spd4 = sin((double)i/ 1250.*3.14159*2.)*500.; // 4 Schwingungen
	MON_TransCeive4(spd4, 1, &pos4, &lim4);

	gotoxy(1,5); printf ("Motor 1: SPD: %15.7f    POS: %15.7f    LIM: %2x     \n", spd1, pos1, lim1);
	gotoxy(1,6); printf ("Motor 2: SPD: %15.7f    POS: %15.7f    LIM: %2x     \n", spd2, pos2, lim2);
	gotoxy(1,7); printf ("Motor 3: SPD: %15.7f    POS: %15.7f    LIM: %2x     \n", spd3, pos3, lim3);
	gotoxy(1,8); printf ("Motor 4: SPD: %15.7f    POS: %15.7f    LIM: %2x     \n", spd4, pos4, lim4);

	gotoxy(1,9); printf ("Time   :      %15.7f\n", time );
  }

  gotoxy(1,12); printf ("Stoppen der Motoren und PowerDown!\n");
  MON_TransCeive1(0., 0, &pos1, &lim1);
  MON_TransCeive2(0., 0, &pos2, &lim2);
  MON_TransCeive3(0., 0, &pos3, &lim3);
  MON_TransCeive4(0., 0, &pos4, &lim4);

}
