/*
-----------------------------------------------------------

   constellation demo program

   (c) 1999,2000 ROALTER - software Int.

-----------------------------------------------------------
*/

#include <stdio.h>
#include <astro/constellation.h>

int main()
{
	int i;
	float ra, dec, t;

	/* We set now up the coordinates and the time */

	ra = 12.2341;
	dec = -40.2341;
	t = 0.0;		/* J2000.0 */

	/* First load the data files  (from const_check.c) */
	i = load_names("../databases/constellation.names");
	if (i == LOAD_FILENOTFOUND) {
		printf("Cannot load file\n");
		return (1);
	};
	if (i == LOAD_NOMEMORY) {
		printf("Not enough memory to load data\n");
		return (1);
	};

	i = load_bound("../databases/constellation.data");
	if (i == LOAD_FILENOTFOUND) {
		printf("Cannot load file\n");
		return (1);
	};
	if (i == LOAD_NOMEMORY) {
		printf("Not enough memory to load data\n");
		return (1);
	};

	i = get_constellation(ra, dec, t);

	printf("The object with the coordinates (%1.4f ; %1.4f)\nlies in the constellation #%d\n", ra, dec, i);
	printf("The constellation #%d is named %s\n", i, get_fullname(i));

	unload_bound();
	unload_names();
	return (0);
}
