/*
-----------------------------------------------------------

   atime.c / atime.h

   (c) 1999,2000 ROALTER - software Int.

-----------------------------------------------------------
*/

#ifndef _ATIME_H
#define _ATIME_H

/* mjd delivers the Mean Julianic Date. This is the number of days passed
   since 11/17/1858, 0:00.
   Args: day, month, year, hour (all in UT)     */
double mjd(int, int, int, double);

/* jd delivers the Julianic Date, named since JULIUS SCALIGER. Thie is 
   the number of days passed since 1/1/4713 b.C. 
   Args: day, month, year, hour (all in UT)     */
double jd(int, int, int, double);

/* caldat returns to a given mjd the corresponding date. considering the
   change from julianic to gregorianic calendar (10/4/1582), too.
   To pass a julianic date, you have to subtract 2,400,000.5 from the
   julianic date to pass it.
   Args: mjd, day, month, year, hour (in UT)    */
void caldat(double, int *, int *, int *, double *);

/* gmst calculates the Greenwich Mean Sidereal Time for a given modified
   julianic date (mjd).
   Args: mjd                                    */
double gmst(double);

/* lmst calculates the Local Mean Sidereal Time for a given modified 
   julianic date (mjd). The equatorial length of the user position is 
   required. lmst(t, 0) == gmst(t). The lmst is the same on every 
   equatorial width.
   Args: mjd, lambda                            */
double lmst(double, double);

#endif
