/*
-----------------------------------------------------------

   coord.c / coord.h

   (c) 1999,2000 ROALTER - software Int.

-----------------------------------------------------------
*/

#ifndef _COORD_H
#define _COORD_H

/*
   cart converts polar coordinates into cartesian coordinates. 
   Args: radius, theta, phi, x, y, z    */
void cart(double, double, double, double *, double *, double *);

/*
   polar converts cartesian coordinates into polar coordinates.
   Args: x, y, z, radius, theta, phi    */
void polar(double, double, double, double *, double *, double *);

/*
   ddd converts degrees, minutes and seconds in degrees.
   Args: deg, min, sec, dd              */
void ddd(int, int, double, double *);

/*
   dms extracts degrees, minutes and seconds from degrees.
   Args: dd, deg, min, sec              */
void dms(double, int *, int *, double *);

/* some data types */
struct c_cart {
	double x, y, z;
};

struct c_polar {
	double azm, elv, dst;
};

#endif
