/*
-----------------------------------------------------------

   fast.c / fast.h

   (c) 2000 ROALTER - software Int.

----------------------------------------------------------
*/

#ifndef _FAST_H
#define _FAST_H

/* moonfast calculates the position of the moon and returns equatorial
   coordinates. Accuracy is only 5' - 1' and should be enough for rise/setting
   calculations
   Args: t, ra, dec	*/
void moonfast(double, double *, double *);

/* sunfast_equ calculates the position of the sun and returns equatorial
   coordinates. Accuracy is only 1' - should be enough for rise/setting
   calculations
   Args: t, ra, dec	*/
void sunfast(double, double *, double *);

/* 
   Args: t, l, b, r	*/
void mercuryfast(double, double *, double *, double *);

/* 
   Args: t, l, b, r	*/
void venusfast(double, double *, double *, double *);

/* 
   Args: t, l, b, r	*/
void earthfast(double, double *, double *, double *);

/* 
   Args: t, l, b, r	*/
void marsfast(double, double *, double *, double *);

/* 
   Args: t, l, b, r	*/
void jupiterfast(double, double *, double *, double *);

/* 
   Args: t, l, b, r	*/
void saturnfast(double, double *, double *, double *);

/* 
   Args: t, l, b, r	*/
void uranusfast(double, double *, double *, double *);

/* 
   Args: t, l, b, r	*/
void neptunefast(double, double *, double *, double *);

/* 
   Args: t, l, b, r	*/
void plutofast(double, double *, double *, double *);

#endif
