/*
-----------------------------------------------------------

   pmat.c / pmat.h

   (c) 1999,2000 ROALTER - software Int.

-----------------------------------------------------------
*/

#ifndef _PMAT_H
#define _PMAT_H

#include <astro/amath.h>

/* pmatecl calculates the precession-matrix between two dates in
   ecliptical coordinates and delivers the conversion matrix.
   Args: t1, t2, a      */
void pmatecl(double, double, real33 *);

/* pmatequ calculates the precession-matrix between two dates in
   equatorial coordinates and delivers the conversion matrix.
   Args: t1, t2, a      */
void pmatequ(double, double, real33 *);

/* precart converts the coordinates through the precession-matrix
   into new coordinates. Caution: the input is also the output!
   Args: a, x, y, z     */
void precart(real33, double *, double *, double *);

/* nutequ transforms mean coordinates into real equatorial coordinates
   Args: t, x, y, z	*/
void nutequ(double, double *, double *, double *);

#endif
