/*
-----------------------------------------------------------

   sphere.c / sphere.h

   (c) 1999,2000 ROALTER - software Int.

-----------------------------------------------------------
*/

#ifndef _SPHERE_H
#define _SPHERE_H

#include <astro/amath.h>

/* eclequ converts eclyptical coordinates into equatorial coordinates.
   the passed argument t is the time in julianic centennials from J2000.
   Args: t, x, y, z     */
void eclequ(double, double *, double *, double *);

/* equecl converts equatorial coordinates into eclyptical coordinates.
   the passed argument t is the time in julianic centennials from J2000.
   Args: t, x, y, z     */
void equecl(double, double *, double *, double *);

/* equhor delivers from given equatorial coordinates horizontal 
   coordinates. phi is the geographic width of the position.
   dec and tau are the positions of the object on sky.
   Args: dec, tau, phi, h, az   */
void equhor(double, double, double, double *, double *);

/* horequ delivers from given horizontal coordinates equatorial
   coordinates. phi is allways the geographic width of the position.
   h and az are height and azimut of the object on sky.
   Args: h, az, phi, dec, tau   */
void horequ(double, double, double, double *, double *);

/*
   Args: xx, yy, pqr, x, y, z	*/
void orbecl(double, double, real33, double *, double *, double *);

/*
   Args: lan, inc, aop, pqr	*/
void gausvec(double, double, double, real33 *);

#endif
