#ifndef __CFG_HH
#define __CFG_HH

#include <string>
#include <map>

/*
 * the sky config file parser (maybe parser.hh would be
 * a better name... however)
 */

void strToMap (const string &str, map<string,string> &m);
void paraToMap (const string &str, map<string,string> &m);

int inline stoi (const string &s, int def=0) { return s.length() ? atoi(s.c_str()) : def; };
double inline stof (const string &s, double def=0) { return s.length() ? atof(s.c_str()) : def; };

class Config {
	struct cpara {
		string head;
		map<string,string> pairs; /* key/value pairs */
	};
	
	map<string,struct cpara> pgs; /* config paragraphs */
	
	string filename;

public:
	Config (const string &file="");
	Config (istream &in);
	~Config ();

	bool load (const string &file="");
	bool load (istream &in);
	bool dump (const string &file="");
	bool dump (ostream &out);
	void clear(void);
	
	string &val(const string &para, const string &key);
	map<string,string> &sec(const string &para);
};

#endif /* __CFG_HH */
