#ifndef __CRONIC_JOBDATA_HH
#define __CRONIC_JOBDATA_HH

#include <stdlib.h>
#include <list>
#include <cronic/time.hh>
#include <string>
#include <map>

// const JobQueued = 1;
// const JobRunning = 2;
// const JobAborted = 3;
// const JobFinished = 4;

class JobData: public map<string,string> {
	Time tstart, tlen;
	//char stat;
	string mod, _id; // do we need this?
	string dummy;
public:
	JobData() {};

	Time start(void) const { return tstart; };
	Time len(void)   const { return tlen; };
	const string& module(void) const { return mod; };
	const string& id(void) const { return _id; };
	//const char &status (void) const { return stat; };

	void setStart(Time t) { tstart = t; };
	void setLen(Time t) { tlen = t; };
	void setMod(const string &str) { mod = str; };
	void setId(const string &str) { _id = str; };

	const string &fetch (const string &key) const
	{
		// once again, STL brain damage example
		for (JobData::const_iterator i = this->begin();
		     i != this->end(); i++) {
			if ((*i).first == key) return (*i).second;
		}
		return this->dummy;
	};

	friend class JobList;
};

// class JobData2: public list<BufferPair> {
// 	Time tstart, tlen;
// 	string mod, _id; // do we need this?
// public:
// 	Time start(void) const { return tstart; };
// 	Time len(void)   const { return tlen; };
// 	const string& module(void) const { return mod; };
// 	const string& id(void) const { return _id; };

// 	void setStart(Time t) { tstart = t; };
// 	void setLen(Time t) { tlen = t; };
// 	void setMod(const string &str) { mod = str; };
// 	void setId(const string &str) { _id = str; };

// 	Buffer *fetch (const Buffer &left);
// 	Buffer *fetch (const char *left);
// 	Buffer *fetch (const string &left) { return this->fetch(left.c_str()); };
	
// 	void append (const Buffer &left, const Buffer &rite)
// 	{ this->push_back(BufferPair(left,rite)); };

// 	void append (Buffer *l, Buffer *r)
// 	{ this->push_back(BufferPair(l,r)); };

// 	void append (const string &l, const string &r)
// 	{ this->append (new Buffer (l.c_str(), l.length()+1),
// 			new Buffer (r.c_str(), r.length()+1)); };

// 	void append (const BufferPair &pair)
// 	{ this->push_back(pair); };

// 	friend class JobList;
// };

extern "C" {
	JobData *factory_JobData(void);
};

#endif /* __CRONIC_JOBDATA_HH */
