#ifndef __CRONIC_TIME_HH
#define __CRONIC_TIME_HH

#include <time.h>
#include <sys/timeb.h>

#define TIME_FORMAT "%Y/%m/%d %T"

typedef double Time;

inline Time to_time (const char *str, const char *fmt)
{
	struct tm tm;
	strptime (str, fmt, &tm);
	return Time(mktime(&tm));
}

inline Time UTC(void)
{
	struct timeb t;
	ftime (&t);
	return Time(t.time)+Time(t.millitm)/1000.0;
}

#endif /* __CRONIC_TIME_HH */
