#ifndef __JOBLISTDIR_HH
#define __JOBLISTDIR_HH

#include <cronic/joblist.hh>
#include <dirent.h>
#include <iostream>

class JobListDir: public JobList {
	string dirname;
	DIR *dir;

	bool closestTo (Time ref, bool after, JobData &data);
	void dataIn (istream &in, JobData &data);
	void dataOut (ostream &out, const JobData &data);

	bool parseName (const char *str, Time &s, Time &l, string &mod);

public:
	JobListDir();
	JobListDir(const string &dir);
	~JobListDir();

	void init(const string &dir);
	void init(map<string,string> &cfg);
	void cleanup(void);

	void validate(JobData &data);
	bool empty(void);
	bool earliest(JobData &data);
	void discardEarliest(void);
	bool schedule(const JobData &data);
	void lock(void);
	void unlock(void);

	// some more stuff
	bool find (const string &id, JobData &data);
	bool discard (const string &id);

	// we need this to view the items.
	// still wonder where to put these...
	// i wouldn't like them in the ABC

	bool firstItem (JobData &data); // return true if successful
	bool nextItem (JobData &data);
};

extern "C" {
	JobListDir *factory_JobListDir(void);
};

#endif /* __JOBLISTDIR_HH */

