#ifndef __CORE_JOBSHELL_HH
#define __CORE_JOBSHELL_HH

#include <cronic/jobshell.hh>
#include <tcpip/client.hh>

#define RESULTDIR "/var/spool/skylark/results/"

class JobShellCore: public JobShell {
	int drvfd, camfd;
	TCPClient drvcli, camcli;
	string drvaddr, camaddr;
	int drvport, camport;
	const string dummystr;

	bool drv_lock (const string &desc);     // check, init, whatever...
	bool drv_work (const string &odesc,
		       const string &oroute);   // send the data to work
	void drv_unlock (void);                 // stop, cleanup, blabla

	bool cam_lock (const string &desc);
	bool cam_work (int top, int left, int width, int height,
		       int hbin, int vbin, long int itime, const string &output);
	void cam_unlock (void);

	void cam_recv_jpeg (int fd, const string &output);

	bool check_perm (const string &user, const string &pass);

	void fail (const char *fmt, ...);

	const string &d (const JobData &data, const string &key)
	{ return data.fetch(key); };
	
public:
	JobShellCore(const string &str="");
	~JobShellCore();

	void init(const string &i);
	void init(map<string,string> &cfg);
	void cleanup(void);
	bool exec (const JobData &data);
};

extern "C" {
	void *factory_JobShellCore (void);
};

#endif /* __CORE_JOBSHELL_HH */
