#include <sky/user/cgi.hh>
#include <sky/user/cgi2.hh>
#include <fstream>
#include <string>
#include <unistd.h>
#include <stdarg.h>

#include <sky/user/user.hh>

// additional stuff to Todor's CGI lib

bool cgi_send_file (const string &fname, map<string,string> *chmap)
{
	if (!fname.length()) return false;
	
	ifstream st (fname.c_str());
	string thefile("");

	if (st.fail()) return false;

	char line[8193];
	int len;
	while (!st.getline(line, 8192).eof()) {
		if (line[0]) {
			thefile += line;
			thefile += "\n";
		}
		line[0]=0;
	}
	// write the last line
	if (line[0]) thefile += line;

	if (chmap) {
		for (map<string,string>::iterator i=chmap->begin();
		     i != chmap->end(); i++) {
			replace_str (thefile, (*i).first, (*i).second);
		}
	}

	cout << thefile;

	return true;
}

void replace_str (string &text, const string &pat, const string &by)
{
	if (by.find(pat) < text.length()) return;
	string::size_type pos=0, pos2=0;

	while (true) {
		pos = text.find(pat,pos);
		if (pos >= text.length()) goto done;
		text.replace (pos, pat.length(), by);
	}
 done:
	return;
}

UserSession::UserSession (const string &fname)
	:thefile(fname)
{
	if (!thefile.length()) mksesid (thefile);

	char exp[51];
	snprintf (exp, 50, "%d", time(NULL)+SESID_EXPIRES);
	theses["expires"] = exp;
}

UserSession::~UserSession (void)
{
}

void UserSession::mksesid (string &sesid)
{
	char sid[256];
	
	snprintf (sid, 255, "%d-%d", time(NULL), getpid());
	sesid = sid;
}

bool UserSession::store(void)
{
	return skyWriteSession (thefile.c_str(), theses);
}

bool UserSession::restore(void)
{
	theses.clear();
	bool ret = skyReadSession (thefile.c_str(), theses);
	cout << "session restore: " << ret << endl;
	return ret;
}

const string &UserSession::getVal(const string &key, const string &def)
{
	const char *val = cgi_param(key.c_str());
	//cerr << "cgi-param: " << val << " ses: " << theses[key] << endl;
	if (!val) {
		if (!theses[key].length()) theses[key] = def;
	} else {
		theses[key] = val;
	}

	return theses[key];
}

void UserSession::setVal (const string &key, const string &val)
{
	theses[key] = val;
}















