#ifndef __SKY_CGI2_HH
#define __SKY_CGI2_HH

#include <string>
#include <map>

extern "C" {
	bool cgi_send_file (const string &fname, map<string,string> *change_map);
	void replace_str (string &text, const string &pat, const string &by);
	void cgi_send (const char *fmt, ...);
};

#define SESID_EXPIRES 3600 // 1 hour

//
// CGI user session
// Will look for a variable in the CGI params. If it doesn't find it,
// it will look for it in the prefs. if it doesn't find it, it will give up
//
class UserSession {
	string thefile;
	map<string,string> theses;

	void mksesid (string &sesid);
public:
	UserSession (const string &fname="");
	~UserSession (void);

	bool store(void);
	bool restore(void);
	const string &id(void) { return thefile; };

	const string &getVal(const string &key, const string &def="");
	void setVal (const string &key, const string &val);
};

#endif /* __SKY_CGI2_HH */
