#include <sky/user/user.hh>
#include <fstream>

bool skyCheckUser (const char *name, const char *pass)
{
	return true;
}

bool skyReadSession (const char *session_id,
		    map<string,string> &data)
{
	string sname (SESID_DIR);
	sname += session_id;
	ifstream sin (sname.c_str());

	if (sin.fail()) return false;

	data.clear();
	char line[256];
	string left, right;
	bool r=false;
	
	while (!(sin.getline(line,255)).eof()) {
		if (*line && *line!='#') {
			if (r) {
				right+=line;
				line[0]=0;
			} else {
				r=true;
				left=line;
				right.erase();
				line[0]=0;
			}
		} else if (!*line) {
			if (left.length()) {
				data[left] = right;
				left.erase();
			}
			r=false;
		}
	}
	if (left.length()) {
		if (line[0]) right += line;
		data[left] = right;
		left.erase();
	}

	sin.close();
	return true;
}

bool skyWriteSession (const char *session_id,
		      map<string,string> &data)
{
	string sname (SESID_DIR);
	sname += session_id;
	ofstream out (sname.c_str());
	
	if (out.fail()) return false;

	for (map<string,string>::iterator i = data.begin();
	     i != data.end(); i++) {
		if ((*i).second.length()) 
			out << (*i).first << endl << (*i).second << endl << endl;
	}

	out.close();
	return true;
}
