#include <tcpip/client.hh>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include <stdexcept>

TCPClient::TCPClient (const string &a, int port)
	:_addr(a),_port(port),confd(-1)
{
	this->connect();
}

TCPClient::~TCPClient ()
{
	this->disconnect();
}

void TCPClient::disconnect (void)
{
	if (confd > -1) close (confd);
	confd = -1;
}

int TCPClient::connect (const string &a, int p)
{
	this->disconnect();
	if (a.length()) _addr = a;
	if (p > 0) _port = p;
	if (!_addr.length()) return -1;
	if (_port <= 0) return -1;

	cerr << "connecting to: " << _addr << " a.k.a. "<<  a << endl;

	int sock;
	if (-1 == (sock = socket (AF_INET, SOCK_STREAM, 0))) {
		perror ("socket");
		throw runtime_error ("TCPClient::connect: socket failed");
	}
	
	struct sockaddr_in dest;

	dest.sin_family = AF_INET;
	dest.sin_port   = htons(_port);
	dest.sin_addr.s_addr = inet_addr(_addr.c_str());
	bzero (&(dest.sin_zero), 8);

	if (::connect (sock, (struct sockaddr*)&dest, sizeof(struct sockaddr))) {
		perror ("connect");
		throw runtime_error ("TCPClient::connect: connect failed");
	}

	cerr << "TCPClient: got connection on socket " << confd << endl;

	return confd=sock;
}
