#include <tcpip/server.hh>

#include <errno.h>
#include <string.h>
#include <stdexcept>
#include <stdio.h>

TCPServer::TCPServer(int port, int back)
	:_port(port),_sock(0),_conn(0),_backlog(back)
{
}

TCPServer::~TCPServer()
{
}

void TCPServer::start(void)
{

	if (-1 == (_sock = socket (AF_INET, SOCK_STREAM, 0))) {
		throw runtime_error(strerror(errno));
	}

	loc_addr.sin_family = AF_INET;
	loc_addr.sin_port   = htons(_port);
	loc_addr.sin_addr.s_addr = INADDR_ANY;
	bzero (&(loc_addr.sin_zero), 8);

	if (-1 == bind(_sock, (struct sockaddr*)&loc_addr, sizeof(struct sockaddr))) {
		cerr << "bind: " << strerror (errno) << endl;
		throw runtime_error(strerror(errno));
	}

	if (-1 == listen(_sock, _backlog)) {
		cerr << "bind: " << strerror (errno) << endl;
		throw runtime_error(strerror(errno));
	}
}

int TCPServer::accept(void)
{
	socklen_t ssize = sizeof(struct sockaddr_in);
	int fd;
	if (-1 == (fd = ::accept(_sock, (struct sockaddr*)&rem_addr, &ssize))) {
		cerr << "accept: " << strerror(errno) << endl;
		return -1;
	}
	
	cerr << "got connection from: " << inet_ntoa(rem_addr.sin_addr) << endl;

	return fd;
}

void TCPServer::stop(void)
{
	shutdown (_sock, 2);
}
